/*-
 * Copyright (c) 1996-2000 Joe Greco and sol.net Network Services
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: post-addr-ck.c,v 1.1.1.1 2000/02/17 11:34:56 nuser Exp $
 */

#include	<stdio.h>
#include	<string.h>
#include	<ctype.h>

#include	"defs.h"

Prototype int ckaddress(char *addr);

#define		E_NOHOST	-1
#define		E_ALLUPPER	-2
#define		E_UNAME2LONG	-3
#define		E_UNAMEALPHA	-4
#define		E_UNAME2SHORT	-5
#define		E_UNAMEILLEGAL	-6
#define		E_HNAME2LONG	-7
#define		E_HNAMENODOTS	-8
#define		E_HNAMETLD	-9
#define		E_UNAMESPECSEP	-10
#define		E_HNAMEILLEGAL	-11
#define		E_HNAMESPECSEP	-12
#define		E_HNAME2LDILLEG	-13
#define		E_HNAMEFORBID	-14
#define		E_HNAMEDIGIT	-15

int badstring(char *str)
{
	if (	strcasecmp(str, "pussy") && \
		strcasecmp(str, "sex") && \
		strcasecmp(str, "slut") && \
		strcasecmp(str, "sperm") && \
		strcasecmp(str, "anal") && \
		strcasecmp(str, "panties") && \
		strcasecmp(str, "dream") && \
		strcasecmp(str, "stud") && \
		strcasecmp(str, "clit") && \
		strcasecmp(str, "myplace") && \
		strcasecmp(str, "suckcock") && \
		strcasecmp(str, "lust") && \
		strcasecmp(str, "teen") && \
		strcasecmp(str, "fuck") && \
		strcasecmp(str, "cum") && \
		strcasecmp(str, "cunt") && \
		strcasecmp(str, "semen") && \
		strcasecmp(str, "slit") && \
		strcasecmp(str, "ass") && \
		strcasecmp(str, "xxx")
	) {
		return(0);
	}
	return(1);
}





int ck2lddomainname(char *name)
{
	if (strlen(name) < 2) {
		return(E_HNAME2LDILLEG);
	}
	if (badstring(name)) {
		return(E_HNAMEFORBID);
	}
	return(0);
}





int ckhostname(char *name, int len)
{
	char buffer[64];
	char *ptr, *dot;
	int rval;

	/* Host name exceeds buffer */
	if (len > sizeof(buffer) - 1) {
		return(E_HNAME2LONG);
	}

	bzero(buffer, sizeof(buffer));
	memcpy(buffer, name, len);

	/* Check last part.  Needs to be legit. */
	if (! (ptr = strrchr(buffer, '.'))) {
		return(E_HNAMENODOTS);
	}
	ptr++;
	if (	strcasecmp(ptr, "com") && \
		strcasecmp(ptr, "org") && \
		strcasecmp(ptr, "net") && \
		strcasecmp(ptr, "edu") && \
		strcasecmp(ptr, "us")
	) {
		return(E_HNAMETLD);
	}
	*--ptr = '\0';

	/* We now have the host (and maybe domain) name, without the TLD. */

	/* Basic valid character checking */
	for (ptr = buffer; *ptr; ptr++) {
		/* All characters must be alnum, -, or . */ 
		if (! isalnum(*ptr) && ! (*ptr == '-') && ! (*ptr == '.')) {
			return(E_HNAMEILLEGAL);
		}

		/* Symbols must be separated by alnum */
		if (((ptr != buffer) && ((*ptr == '-') || (*ptr == '.')) && ! isalnum(*(ptr - 1)))) {
			return(E_HNAMESPECSEP);
		}
	}

	/* Check if it contains dots.  If so - we have both hostname
	   and domain name */
	if ((dot = strrchr(buffer, '.'))) {
		/* Host name case */
		if ((rval = ck2lddomainname(dot + 1))) {
			return(rval);
		}

		/* Host name leading char can not be a digit */
		if (isdigit(*buffer)) {
			return(E_HNAMEDIGIT);
		}

		/* Remove 2LD name */
		*dot = '\0';

		/* XXX this really sucks */
		if (badstring(buffer)) {
			return(E_HNAMEFORBID);
		}
	} else {
		/* Domain name only case */
		if ((rval = ck2lddomainname(buffer))) {
			return(rval);
		}
	}
	return(0);
}





int ckusername(char *name, int len)
{
	char buffer[32];
	char *ptr;

	/* User name exceeds buffer */
	if (len > sizeof(buffer) - 1) {
		return(E_UNAME2LONG);
	}
	if (len < 2) {
		return(E_UNAME2SHORT);
	}
	bzero(buffer, sizeof(buffer));
	memcpy(buffer, name, len);

	/* MUST start with alpha. */
	if (! isalpha(*buffer)) {
		return(E_UNAMEALPHA);
	}

	/* Basic valid character checking */
	for (ptr = buffer; *ptr; ptr++) {
		/* All characters must be alnum, -, _, or . */ 
		if (! isalnum(*ptr) && ! (*ptr == '-') && ! (*ptr == '_') && ! (*ptr == '.')) {
			return(E_UNAMEILLEGAL);
		}

		/* Symbols must be separated by alnum */
		if (((ptr != buffer) && ((*ptr == '-') || (*ptr == '_') || (*ptr == '.')) && ! isalnum(*(ptr - 1)))) {
			return(E_UNAMESPECSEP);
		}
	}

	return(0);
}





int ckaddress(char *addr)
{
	register char *ptr = addr;
	char *at;
	char *end;
	int flag, rval;
	
	end = addr + strlen(addr);

	/* Can't have an E-mail address without @ */
	if (! (at = strchr(addr, '@'))) {
		return(E_NOHOST);
	}

	/* Strip any trailing space */
	if (strlen(addr) > 1 && *(end - 1) == ' ') {
		*(end - 1) = '\0';
	}

	/* Component check: user name */
	if ((rval = ckusername(addr, at - addr))) {
		return(rval);
	}

	/* Component check: host name */
	if ((rval = ckhostname(at + 1, end - at - 1))) {
		return(rval);
	}

	/* Can't have an all-uppercase E-mail address */
	flag = 0;
	for (ptr = addr; *ptr; ptr++) {
		if (isalpha(*ptr) && islower(*ptr)) {
			flag = 1;
			break;
		}
	}
	if (! flag) {
		return(E_ALLUPPER);
	}
	return(0);
}

#if 0
int main()
{
	char buffer[8192];

	while (! feof(stdin)) {
		gets(buffer);
		if (! feof(stdin)) {
			printf("%d\t'%s'\n", ckaddress(buffer), buffer);
		}
	}
}
#endif
