
/*
 * LIB/VENDOR.H
 *
 * This header file is available for you to specify custom parameters to
 * diablo.
 *
 * WARNING!  Diablo does not use make depend, so any changes you make to
 * this or any other header file should be followed by a complete
 * recompile.  e.g. 'xmake clean; xmake'
 */

/* #undef USE_SMALL_HASH */
/* #define USE_SMALL_HASH 1 */

/* #undef USE_LARGE_HASH */
/* #define USE_LARGE_HASH 1 */

/*
 * The default remember is 14 days.  Defining USE_SHORT_REMEMBER will reduce
 * this to 7.  You can also not bother with that and directly set the
 * remember time in days by setting REMEMBERDAYS.
 *
 *		dhistory (at 800K arts/day)
 *
 * 14 days	350 to 400 MBytes	(11 million message-id's)
 *  7 days	175 to 200 MBytes	( 6 million message-id's)
 */

#undef USE_SHORT_REMEMBER
#define USE_SHORT_REMEMBER 1

/* #define REMEMBERDAYS 9 */

/*
 * Compile in Joe Greco's Diablo-Filter support
 */

/* #define DIABLO_FILTER 1 */

/*
 * When posting an article, check validity of From: address.
 * Note that this is a US-ISP-centric check, and may well
 * disallow slightly unusual addresses that are quite valid.
 * It was designed to deal with a spammer who liked to post
 * with a variety of From: names like "sally@fuck.net"
 *
 * If you use this, check dreaderd/post-addr-ck.c to see if
 * the rules are valid for your purposes.  Should be easy to
 * modify.
 */

#undef	POST_CKADDRESS

/*
 * When posting an article, scan the submitted article for this
 * path element.  If it exists, reject the article.  This also
 * turns on some other checks to try to prevent people from
 * POST'ing articles that they fetched from Usenet back into you.
 */

/* #define POST_CKPATHLOOP "!news.site.com!" */

#undef	POST_CKPATHLOOP

/*
 * When posting an article, force the rewrite of the Message-ID:.
 * YOU MUST USE POST_CKPATHLOOP WITH THIS OPTION, TO AVOID ENDLESS
 * REPOST LOOPS.  This option is controversial, but allows you to
 * do some neat things like restrict cancel messages to Message-ID's
 * generated by your site.
 */

#undef	POST_FORCEMSGID

/*
 * When posting an article, clean up non- or obsolete Usenet
 * headers.
 */

#undef	POST_BOFHCLEANUP

/*
 * When posting a cancel, verify that the original message came from
 * this system.  Requires POST_FORCEMSGID.  Also prevents Supersedes
 * attacks.
 */

#undef	POST_RESTRICTCANCEL

/*
 * When posting a message, encode the NNTP posting host through a one-
 * way function.  This protects your users from being ping-flooded,
 * etc., but permits the identification of posts coming from the same
 * node within a short period of time.  Highly recommended.
 */

#undef	POST_HIDENNTPPOSTHOST

/*
 * When posting a message, encrypt the X-Trace line with DES.  Again,
 * highly recommended.
 */

#undef	POST_CRYPTXTRACE

/*
 * Enable RADIUS authentication.  Works on FreeBSD or similar libradius.
 */

#undef	RADIUS_ENABLED

/*
 * Enable CDB authentication. Needs the CDB libraries installed.
 * Available from: http://cr.yp.to/cdb.html
 *
 * You also need to add the following to the LFLAGS line in XMakefile.inc
 *  -L$(BD)cdb -lcdb
 */

#undef	CDB_ENABLED

