
/*
 * UTIL/DPRIMETHOSTCACHE.C
 *
 * Prime the host cache file from diablo.hosts
 *
 * (c)Copyright 1997, Matthew Dillon, All Rights Reserved.  Refer to
 *    the COPYRIGHT file in the base directory of this distribution 
 *    for specific rights granted.
 */

#include "defs.h"

int
main(int ac, char *av[])
{
    int dodump = 0;
    int arg = 1;

    openlog("dprimehostcache", LOG_PID|LOG_NDELAY, LOG_NEWS);
    
    LoadDiabloConfig(ac, av);

    if (ac > 1) {
	if (strcasecmp(av[arg], "dump") == 0) {
	    arg++;
	    dodump = 1;
	}
	if (av[arg]) {
	    DiabloHostsPat = av[arg];
	    arg++;
	    if (av[arg])
		DHostsCachePat = av[arg];
	}
    }

    if (dodump) {
	printf("Dumping cache data from : %s\n",
		PatDbExpand(DHostsCachePat));
	DumpHostCache(PatDbExpand(DHostsCachePat));
	return(0);
    }
    printf("Loading diablo hosts cache from: %s\n",
		PatLibExpand(DiabloHostsPat));
    printf("Storing cache data into : %s\n",
		PatDbExpand(DHostsCachePat));

    LoadHostAccess(0, 1, 0);

    printf("Complete.\n");
    return(0);
}

